'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.liftA2 = liftA2;
exports.liftA3 = liftA3;
exports.liftA4 = liftA4;

var _HKT = require('./HKT');

function liftA2(apply, f) {
  var cf = function cf(a) {
    return function (b) {
      return f(a, b);
    };
  };
  return function (fa, fb) {
    return apply.ap(apply.map(cf, fa), fb);
  };
}
function liftA3(apply, f) {
  var cf = function cf(a) {
    return function (b) {
      return function (c) {
        return f(a, b, c);
      };
    };
  };
  return function (fa, fb, fc) {
    return apply.ap(apply.ap(apply.map(cf, fa), fb), fc);
  };
}

function liftA4(apply, f) {
  var cf = function cf(a) {
    return function (b) {
      return function (c) {
        return function (d) {
          return f(a, b, c, d);
        };
      };
    };
  };
  return function (fa, fb, fc, fd) {
    return apply.ap(apply.ap(apply.ap(apply.map(cf, fa), fb), fc), fd);
  };
}